The aim of this chapter is to introduce to
hybrid high order (HHO) methods
within the \Rheolef\  environment.
For a review of hybrid high order methods,
and its link to hybrid discontinuous Galerkin (HDG) methods,
see~\cite{CocPieErn-2016}.
Let us start by some model problems.

% -----------------------------------------------------------------------
\subsection{The diffusion problem}
% -----------------------------------------------------------------------
\pbindex{diffusion}%
\cindex{boundary condition!Dirichlet}%
Let us consider an anisotropic diffusion problem with
homogeneous Dirichlet conditions:

\ \ $(P)$: \emph{find $u$, defined in $\Omega$, such that}
\begin{subequations}
\begin{empheq}[left={\empheqlbrace}]{align}
  -\mathrm{div}(\boldsymbol{A}\nabla u) &= f 
	\ \mbox{ in } \ \Omega
  \label{eq-diffusion-u}
	\\
  u &= 0
	\ \mbox{ on } \ \partial\Omega
  \label{eq-diffusion-bc}
\end{empheq}
\end{subequations}
where the right-hand-side~$f$ 
and the diffusion~$\boldsymbol{A}$ are given functions.
The diffusion is assumed to be bounded, symmetric,
uniformly positive definite matrix-valued function.
Observe that when~\mbox{$\boldsymbol{A}=\boldsymbol{I}$},
the problem reduces to the usual Poisson problem
with homogeneous Dirichlet conditions.

% -----------------------------------------------------------------------
\subsection{The reconstruction operator}
% -----------------------------------------------------------------------
The cornerstone of the HHO method is the reconstruction operator.
Let~\mbox{$k\geq 0$} and~\mbox{$\ell\in\{k\!-\!1,k,k\!+\!1\}$} be two integers
and let us introduce the following finite element spaces:
\begin{eqnarray*}
  X_h
  &=&
  \left\{
    v_h\in L^2(\Omega)
    \ ;\ 
    v_{h|K} \in P_\ell
    ,\ \forall K\in \mathscr{T}_h
  \right\}
  \\
  M_h
  &=&
  \left\{
    \mu_h\in L^2(\mathscr{S}_h)
    \ ;\ 
    \mu_{h|S} \in P_k
    ,\ \forall S\in \mathscr{S}_h
  \right\}
  \\
  X_h^*
  &=&
  \left\{
    v_h^*\in L^2(\Omega)
    \ ;\ 
    v^*_{h|K} \in P_{k+1}
    ,\ \forall K\in \mathscr{T}_h
  \right\}
\end{eqnarray*}
The \emph{reconstruction operator}~\cite[p.~637]{CocPieErn-2016}
is defined by
\[
    \begin{array}{cccl}
      r_h: & X_h\times M_h & \longrightarrow  & X_h^* \\
           &(u_h,\lambda_h)& \longmapsto      & u_h^* = r_h(u_h,\lambda_h)
     \end{array}
\]
where~$u_h^*\in X_h^*$ is characterized by a collection of local
constrained minimization problems,
associated to local Neumann problems similar to those
previously introduced for the HDG method,
in subsection~\ref{subsec-hdg-postprocessing},
     page~\pageref{subsec-hdg-postprocessing}:
\begin{eqnarray*}
  u_h^*
  &=&
  \arginf_{v_h^*\in X_h^*}
  \Frac{1}{2}
  \int_\Omega
    |\nabla_h (v_h^*-u_h)|_{\boldsymbol{A}}^2
    \,\mathrm{d}x
  -
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
     (\lambda_h - u_h)
    \ 
    \left( 
      \boldsymbol{A}
      \nabla v_h^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \\
  && \mbox{subject to}
  \int_K  
    v_h^*
    \,\mathrm{d}x
  \ = \ 
  \int_K  
    u_h
    \,\mathrm{d}x
  ,\ \ \forall K\in\mathscr{T}_h
\end{eqnarray*}
For any symmetric definite positive matrix
$\boldsymbol{c}$, 
we denote by~$|.|_{\boldsymbol{c}}$ the anisotropic norm in~$\mathbb{R}^d$
defined by
\mbox{$
  |\boldsymbol{\xi}|_{\boldsymbol{c}}^2
  =
  \boldsymbol{\xi}
  .({\boldsymbol{c}} \boldsymbol{\xi})
$}
for all
\mbox{$
  \boldsymbol{\xi}\in \mathbb{R}^d
$}.
%
The constraint corresponds to the closure for the local Neumann problems,
as otherwise the solution would be defined up to a constant
in each element~\mbox{$\forall K\in\mathscr{T}_h$}.
This constrained minimization problem is not convenient for the numerical
resolution: we prefer to express it as a saddle-point problem
by introducing a Lagrange multiplier~$\zeta_h\in Z_h$ with
\begin{eqnarray*}
  Z_h
  &=&
  \left\{
    \xi_h\in L^2(\Omega)
    \ ;\ 
    \xi_{h|K} \in P_0
    ,\ \forall K\in \mathscr{T}_h
  \right\}
\end{eqnarray*}
The corresponding Lagrangian writes
\begin{eqnarray}
  L_\gamma(u^*,\zeta)
  &=&
  \Frac{1}{2}
  \int_\Omega
    |\nabla_h (u^*-u_h)|_{\boldsymbol{A}}^2
    \,\mathrm{d}x
  -
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
     (\lambda_h - u_h)
    \ 
    \left( 
      \boldsymbol{A}
      \nabla u^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \nonumber
  \\
  &&
  \ +\ 
  \int_\Omega  
    (u^* - u_h)
    \,\zeta
    \,\mathrm{d}x
  -
  \int_\Omega
    \Frac{\gamma}{2}
    \zeta^2
    \,\mathrm{d}x
  \label{eq-hho-reconstruction-lagrangian}
\end{eqnarray}
Observe that the first two terms of the Lagrangian
correspond to the minimization functional.
The third term is associated to the constraint
with its associated Lagrangian multiplier.
When~$\gamma=0$, the fourth term vanishes 
and thus, the saddle-point of the  Lagrangian
is equivalent to the previous constrained minimization problem.
The fourth term, when the augmentation parameter~$\gamma>0$
will be discussed later: in that case,
$L_\gamma$ is related to the augmented Lagrangian.
The saddle-point problem expresses:
\begin{eqnarray*}
  (u_h^*,\zeta_h)
  &=&
  \arginf_{v_h^*\in X_h^*}
  \sup_{\xi_h Z_h}
  L_\gamma(v_h^*,\xi_h)
\end{eqnarray*}
Since~$L_\gamma$ is differentiable, its saddle point is also
characterized as the unique solution of the following collection
of local variational problems:

\ \ $(FV^*)_h$: \emph{let $(u_h,\lambda_h)\in X_h\times M_h$ being given,
                 find $(u_h^*,\zeta_h) \in X_h^*\times Z_h$ such that}
\begin{empheq}[left={\empheqlbrace}]{align*}
  \int_K  
    \nabla u_h^*
    .
    \left( 
      \boldsymbol{A}
      \nabla v_h^*
    \right)
    \,\mathrm{d}x
  +
  \int_K  
    v_h^*
    \zeta_h
    \,\mathrm{d}x
  &=
  \int_K  
    \nabla u_h
    .
    \left( 
      \boldsymbol{A}
      \nabla v_h^*
    \right)
    \,\mathrm{d}x
  +
  \int_{\partial K}
    (\lambda_h - u_h)
    \ 
    \left( 
      \boldsymbol{A}
      \nabla v_h^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \\
  \int_K  
    u_h^*
    \xi_h
    \,\mathrm{d}x
  -
  \int_K  
    \gamma
    \zeta_h
    \xi_h
    \,\mathrm{d}x
  &=
  \int_K  
    u_h
    \xi_h
    \,\mathrm{d}x
\end{empheq}
for all~$K\in\mathscr{T}_h$
and all~$(v_h^*,\xi_h)\in X_h^*\times Z_h$.
Observe that, for any~$K\in\mathscr{T}_h$, we can choose
the test function~$v_h^*$ as equal to~1 in~$K$
and zero elsewhere in~$\Omega$.
Then, the first equation leads to~$\zeta_h=0$ in~$K$.
Since this could be repeated for
any~$K\in\mathscr{T}_h$, we obtain~$\zeta_h=0$.
\index{penalization}%
\index{augmented Lagrangian}%
As a consequence, the term factored by~$\gamma\geq 0$
has no influence upon the solution~$(u_h^*,\zeta_h)$
which is independent upon~$\gamma$:
in this sense, this is not a \emph{penalization} parameter,
but an \emph{augmented Lagrangian} parameter.
Up to now, we assume~$\gamma>0$:
we will show how it facilitates the numerical resolution of the system.

Let, for all
$u^*,v\*\in X_h^*$,
$\zeta,\xi\in Z_h^*$,
$u\in X_h$
and
$\lambda \in M_h$:
\begin{subequations}
\begin{eqnarray}
  a_*(u^*,v^*)
  &=&
  \int_\Omega  
    \nabla_h u^*
    .
    \left( 
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    \,\mathrm{d}x
  \label{eq-hho-reconstruction-as}
  \\
  b_*(u^*,\xi)
  &=&
  \int_\Omega  
    u^* \xi
    \,\mathrm{d}x
  \label{eq-hho-reconstruction-bs}
  \\
  c_*(\zeta,\xi)
  &=&
  \int_\Omega  
    \gamma\,
    \zeta \, \xi
    \,\mathrm{d}x
  \label{eq-hho-reconstruction-cs}
  \\
  \check{a}(u,v^*)
  &=&
  \int_\Omega
    \nabla_h u
    .
    \left( 
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    \,\mathrm{d}x
  -
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    u
    \, 
    \left( 
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \nonumber
  \\
  b(u,\xi)
  &=&
  \int_\Omega
      u\, \xi
    \,\mathrm{d}x
  \nonumber
  \\
  e_*(u^*,\mu)
  &=&
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \mu
    \,
    \left( 
      \boldsymbol{A}
      \nabla_h u^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \nonumber
\end{eqnarray}
\end{subequations}
Then, the previous reconstruction problem writes:

\ \ $(FV^*)_h$: \emph{let $(u_h,\lambda_h)\in X_h\times M_h$ being given,
                 find $(u_h^*,\zeta_h) \in X_h^*\times Z_h$ such that}
\begin{eqnarray*}
  a_*(u_h^*,v_h^*)
  +
  b_*(v_h^*,\zeta_h)
  &=&
  \check{a}(u_h,v_h^*)
  +
  e_*(v_h^*,\lambda_h)
  ,\ \ \forall v_h^* \in X_h^*
  \\
  b_*(u_h^*,\xi_h)
  -
  c_*(\zeta_h,\xi_h)
  &=&
  b(u_h,\xi_h)
  ,
\phantom{
  \ +\ 
  e_*(v_h^*,\lambda_h)
}
  \,\ \ \forall \xi_h \in Z_h
\end{eqnarray*}
By identifying the bilinear forms 
and the associated matrix,
the previous linear problem
also expreses in matrix-vector form:
\begin{eqnarray*}
  \left( \begin{array}{cc}
    a_* & b_*^T \\
    b_* & -c_*
  \end{array} \right)
  \left( \begin{array}{c}
    u_h^* \\ \zeta_h
  \end{array} \right)
  &=&
  \left( \begin{array}{cc}
    \check{a} & e_* \\
    b   & 0
  \end{array} \right)
  \left( \begin{array}{c}
    u_h \\ \lambda_h
  \end{array} \right)
\end{eqnarray*}
A carreful study shows that the matrix on the left-hand-side
has a block-diagonal structure at the element level
and its inverse can be easily constructed explicitly
by inverting on the fly the element matrix during the assembly process.
Then, the result of reconstruction operator can be obtained
at low computational cost, by simple matrix-vector multiplication.

A further improvement can be obtained.
Observe that the matrix on the left-hand-side
is symmetric but definite: at the element level,
it admits both positive and negative eigenvalues,
due to the saddle point structure.

Expanding the previous linear system, we obtain
\begin{empheq}[left={\empheqlbrace}]{align*}
  a_*u_h^* + b_*^T \zeta_h
  &=
  \check{a} u_h + e_*^T \lambda_h
  \\
  b_* u_h^* -c_* \zeta_h
  &=
  b   u_h
\end{empheq}
Since the~$c_*$ matrix is diagonal, 
when choosing~$\gamma > 0$, 
the~$\zeta$ unknown could be eliminated at the element level:
\begin{empheq}{align}
  &
  \zeta_h
  =
  c_*^{-\!1}
  \left(
    b_* u_h^* 
    -
    b u_h
  \right)
  \nonumber
  \\
  &
  u_h^*
  =
  S_*^{-\!1}
  \left(
    S_h u_h
    +
    e_*^T \lambda_h
  \right)
  \nonumber
  \\
  \textrm{with }
  &
  S_*
  =
  a_*
  +
  b_*^T
  c_*^{-\!1}
  b_*
  \label{eq-hho-reconstruction-ss}
  \\
  &
  S_h
  =
  \check{a}
  +
  b_*^T
  c_*^{-\!1}
  b
  \nonumber
\end{empheq}
Since we known that~$\zeta_h=0$, the corresponding computation
has no importance, expect for checking purpose,
and let us turn to those of~$u_h^*$.
\cindex{matrix!Schur complement}%
The Schur complement~$S_*$ is still block-diagonal at the element level
and, moreover, it is then symmetric definite positive.
This is of major importance
when considering iterative solvers,
e.g. for tridimensional geometries.
Let us turn to the practical choice of~$\gamma>0$.
An investigation of~\eqref{eq-hho-reconstruction-as}
shows that entries of~$a_*$ scales as~$\mathcal{O}(h^{d-2})$.
The~$h^{d}$ comes from the integration measure~$\mathrm{d}x$
and the~$h^{-2}$,from the two derivations~$\nabla_h$.
Conversely, assuming~$\gamma$ independent upon the mesh size~$h$,
the entries for~$b_*$ and~$c_*$,
from~\eqref{eq-hho-reconstruction-bs}
and~\eqref{eq-hho-reconstruction-cs}, respectively,
scales as~$\mathcal{O}(h^{d})$ since there is no derivation
in~$b_*$ and~$c_*$,
Then, \mbox{$b_*^T c_*^{-\!1} b_*$} scales
as~$\mathcal{O}(h^{d})$.
Then, the expression~\eqref{eq-hho-reconstruction-ss} for~$s_s$
is not equilibrated.
Choosing~$\gamma=\alpha h^{2}$, 
with~$\alpha>0$ independent upon~$h$,
leads to
\mbox{$b_*^T c_*^{-\!1} b_*$} that scales
as~$\mathcal{O}(h^{d-2})$, i.e. as~$a_*$.
This $h$-dependent choice for~$\gamma$
dramatically improves the condition number for~$S_*$.
%
Note that \cite[p.~454]{PieDro-2020-hho}, eqn~(B.7),
proposed a similar implementation,
despites it based on different notations and concepts.

%% This could be achieved by writting:
%% \begin{lstlisting}[numbers=none,frame=none]
%%   auto as  = lazy_integrate (dot(grad_h(us),a(d)*grad_h(vs)));
%%   auto bs  = lazy_integrate (us*xi);
%%   auto cs  = lazy_integrate (-alpha*zeta*xi);
%%   auto ah  = lazy_integrate (dot(grad_h(u),a(d)*grad_h(vs)) + alpha*u*vs
%%                - on_local_sides(u*dot(normal(),a(d)*grad_h(vs))));
%%   auto b1  = lazy_integrate (u*xi);
%%   auto b2h = lazy_integrate (
%%                  on_local_sides(lambda*dot(normal(),a(d)*grad_h(vs))));
%%   auto ss  = as + trans(bs)*inv(cs)*bs;
%%   auto sh  = ah + trans(bs)*inv(cs)*b1;
%% \end{lstlisting}
%% The \code{lazy_integrate} function delays the 
%% assembly process from element matrix to a whole sparse matrix.
%% Then, objects returned by \code{lazy_integrate} could be represented
%% as a stream of element matrix, that could be transposed or
%% inverted on the fly during the assembly loop.
%% These objects, similar to expressions
%% have complex recursive C++ types,
%% that are handled by the \code{auto} C++ type.
%% They can be at any moment converted to a \code{form}:
%% at this stage, the effective element matrix computation
%% and the whole assembly process is achived for
%% the recursive expressions.
%% 
%% The \code{lazy_integrate} function is not yet available
%% in \Rheolef: we turn to an assembly of the reconstruction
%% operator without the elimination of the~$\zeta_h$ multiplier.
%% The obtained matrix is no more symmetric definite positive
%% and the process is only suitable for direct solvers,
%% e.g. bidimensional geometries.
%% 
%% Let
%% \begin{eqnarray*}
%%   A_h^*(u^*,\zeta ;~ v^*,\xi)
%%   &=&
%%   \int_\Omega  
%%     \left(
%%       \nabla_h u^*
%%       .
%%       \left( 
%%         \boldsymbol{A}
%%         \nabla_h v^*
%%       \right)
%%       +
%%       v^* \zeta
%%       +
%%       u^* \xi
%%     \right)
%%     \,\mathrm{d}x
%%   \\
%%   L(v^*,\xi)
%%   &=&
%%   \int_\Omega
%%     \left(
%%       \nabla_h u_h
%%       .
%%       \left( 
%%         \boldsymbol{A}
%%         \nabla_h v^*
%%       \right)
%%       +
%%       u_h
%%       \xi
%%     \right)
%%     \,\mathrm{d}x
%%   +
%%   \sum_{K\in\mathscr{T}_h}
%%   \int_{\partial K}
%%     (\lambda_h - u_h)
%%     \ 
%%     \left( 
%%       \boldsymbol{A}
%%       \nabla_h v^*
%%     \right)
%%     .
%%     \boldsymbol{n}
%%     \,\mathrm{d}s
%% \end{eqnarray*}
%% Then, the previous reconstruction problem writes:
%% 
%% \ \ $(FV^*)_h$: \emph{let $(u_h,\lambda_h)\in X_h\times M_h$ being given,
%%                  find $(u_h^*,\zeta_h) \in X_h^*\times Z_h$ such that}
%% \begin{eqnarray*}
%%   A_h^*(u_h^*,\zeta_h ;~ v_h^*,\xi_h)
%%   &=&
%%   L(v_h^*,\xi_h)
%%   ,\ \ \forall (v_h^*,\xi_h) \in X_h^*\times Z_h
%% \end{eqnarray*}

% -------------------------------------
\myexamplelicense{reconstruction_hho.cc}

\myexamplenoinput{diffusion_isotropic.h}

\myexamplenoinput{sinusprod_error_hho_reconstruction.cc}

\myexamplenoinput{sinusprod.h}
% -------------------------------------

\begin{figure}[htb]
  \begin{center}
    \begin{tabular}{ll}
      \includegraphics[width=0.42\textwidth]{reconstruction-hho-error-l2-t.pdf} &
      \includegraphics[width=0.42\textwidth]{reconstruction-hho-error-h1-t.pdf}
    \end{tabular}
  \end{center}
  \caption{Hybrid hight-order (HHO) method:
	error vs~$h$ and~$k$ for the reconstruction operator.
  }
  \label{fig-reconstruction-hho}
\end{figure}

%---------------------------------------
\subsubsection*{How to run the program}
%---------------------------------------
The compilation and run write:
\begin{verbatim}
  make reconstruction_hho sinusprod_error_hho_reconstruction
  mkgeo_grid -t 10 > square.geo
  ./reconstruction_hho square.geo P1d P1d | ./sinusprod_error_hho_reconstruction
\end{verbatim}

\cindex{projection!in {$L^2$} norm}%
The code \file{reconstruction_hho.cc} 
first computes~$u_h$ and~$\lambda_h$ as $L^2$ projections 
on~$X_h$ and~$M_h$, respectively, of a given function:
\begin{equation*}
  u(x) = \prod_{i=0}^{d\!-\!1} \sin(\pi x_i)
\end{equation*}
Then, it builds the reconstruction~\mbox{$u_h^*=r_h(u_h,\lambda_h)$}
and output the result.
Next, the code \file{sinusprod_error_hho_reconstruction.cc}
shows the $L^2$ and~$H^1$ error for the reconstruction~$u_h^*$.
The files \file{sinusprod.h}, \file{diffusion_isotropic.h},
and \file{sinusprod_error_hho_reconstruction.cc},
that defines~$u$ and~$\boldsymbol{A}$,
and that compute the errors, respectively,
are not listed here but is available in the \Rheolef\  example directory.
Fig.~\ref{fig-reconstruction-hho} plots the error versus mesh size~$h$
and the polynomial order~$k$:
the convergence order is $k+2$ in the~$L^2$ norm and~$k+1$ in the~$H^1$ one,
as expected
(see~\cite{CocPieErn-2016}, eqn~(2.9) or~\cite{PieErn-2015-c}, eqn~(3)).

% -----------------------------------------------------------------------
\subsection{The projections}
% -----------------------------------------------------------------------
\cindex{projection!in {$L^2$} norm}%
Let~$\pi_{X_h}$ denotes the~$L^2$ projection
from~$L^2(\Omega)$ into~$X_h$.
For all~\mbox{$u^*\in L^2(\Omega)$},
it is defined as 
\mbox{$\pi_{X_h}(u^*)=\check{u}_h\in X_h$},
where~$\check{u}_h$ is the solution of the following quadratic minimization problem: 
\begin{eqnarray*}
  \check{u}_h
  &=&
  \arginf_{\check{v}_h\in X_h}
  \ 
  \Frac{1}{2}
  \int_\Omega
    (u^* - \check{v}_h)^2
    \mathrm{d}x
\end{eqnarray*}
Let us consider the special case of computing
the projection
\mbox{$\check{u}_h=\pi_{X_h}(u_h^*)\in X_h$}
of an element~\mbox{$u_h^*\in X_h^*$}.
The following bilinear forms are introduced:
\begin{eqnarray*}
  m(\check{u},\check{v})
  &=&
  \int_\Omega  
    \check{u} \, \check{v}
    \,\mathrm{d}x
  \\
  d_*(u^*,\check{v})
  &=&
  \int_\Omega
    u^* \, \check{v}
    \,\mathrm{d}x
\end{eqnarray*}
Then, the projection reduces to:

\ \ \emph{let $u_h^*\in X_h^*$ being given, find $\check{u}_h\in X_h$ such that}
\begin{eqnarray*}
  m(\check{u}_h,\check{v}_h)
  &=&
  d_*(u_h^*,\check{v}_h)
  ,\ \ \forall \check{v}_h\in X_h
\end{eqnarray*}
Note that the matrix associated to the bilinear form~$m$
from~$X_h\times X_h$ to~$\mathbb{R}$
has a block-diagonal structure at the element level
and can be easily inverted on the fly during the assembly process.
Then, the result of projection operator can be obtained
by simple matrix-vector multiplication.

\apindex{discontinuous!trace}%
Let us reintroduce the following space~$\tilde{M}_h$,
already defined
    in~\eqref{eq-hdg-def-mh-tilde},
page~\pageref{eq-hdg-def-mh-tilde},
in the context of the HDG method:
\begin{eqnarray*}
  \tilde{M}_h
  &=&
  \displaystyle
  \prod_{K \in \mathscr{T}_h}
  \left\{
    \tilde{\boldsymbol{\tau}}_{|\partial K}
    .\boldsymbol{n}
    \ ;\ 
    \tilde{\boldsymbol{\tau}}\in RT_{k}(K)
  \right\}
  \ =\ 
  \displaystyle
  \prod_{K \in \mathscr{T}_h}
  \prod_{S \subset \partial K}
  P_{k}(S)
\end{eqnarray*}
Let~$\pi_{\tilde{M}_h}$ denote the~$L^2$ projection
into~$\tilde{M}_h$.
We consider the special case of computing
the projection~$\tilde{\delta}_h=\pi_{\tilde{M}_h}(u_h^*)\in \tilde{M}_h$
of an element~$u_h^*\in X_h^*$.
It is defined as 
\begin{eqnarray*}
  \tilde{\delta}_h
  &=&
  \arginf_{\tilde{\varphi}_h\in \tilde{M}_h}
  \ 
  \Frac{1}{2}
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    (u_h^* - \tilde{\varphi}_h)^2
    \mathrm{d}s
\end{eqnarray*}
Note that~$u_h^*\in X_h^*$ is bi-valued and~$P_{k+1}$
on all internal side while its
projection~\mbox{$\tilde{\delta}_h=\pi_{\tilde{M}_h}(u_h^*)\in \tilde{M}_h$}
is also bi-valued but only~$P_{k}$.
The following bilinear forms are introduced:
\begin{eqnarray*}
  \tilde{m}(\tilde{\delta},\tilde{\varphi})
  &=&
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \tilde{\delta} \, \tilde{\varphi}
    \,\mathrm{d}s
  \\
  \tilde{d}_*(u^*,\tilde{\varphi})
  &=&
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    u^* \, \tilde{\varphi}
    \,\mathrm{d}s
\end{eqnarray*}
Then, the projection reduces to:

\ \ \emph{let $u_h^*\in X_h^*$ being given, find $\tilde{\delta}_h\in \tilde{M}_h$ such that}
\begin{eqnarray*}
  \tilde{m}(\tilde{\delta}_h,\tilde{\varphi}_h)
  &=&
  \tilde{d} (u_h^*,\tilde{\varphi}_h)
  ,\ \ \forall \tilde{\varphi}_h\in \tilde{M}_h
\end{eqnarray*}
Here also, the matrix associated to the bilinear form~$m_s$
from~$\tilde{M}_h\times \tilde{M}_h$ to~$\mathbb{R}$
has a block-diagonal structure at the element level
and can be easily inverted on the fly during the assembly process.
Then, the result of projection operator can be obtained
by simple matrix-vector multiplication.

% -----------------------------------------------------------------------
\subsection{The discrete problem statement}
% -----------------------------------------------------------------------
The discretization of the diffusion problem~\eqref{eq-diffusion-u}-\eqref{eq-diffusion-bc}
by the hybrid high-order (HHO) method~\cite[p.~639]{CocPieErn-2016}
is expressed here as a minimization problem:
\begin{eqnarray*}
  (u_h,\lambda_h)
  &=&
  \argmin_{v_h\in X_h}
  \max_{\mu_h\in M_h(0)}
  L_1(v_h,\mu_h)
\end{eqnarray*}
with
\begin{eqnarray*}
  L_1(u,\lambda)
  &=&
  \int_\Omega
    \left(
      \Frac{1}{2}
      |\nabla_h r_h(u,\lambda)|_{\boldsymbol{A}}^2
      -
      f \, u
    \right)
    \,\mathrm{d}x
  \\
  &&
  + \ 
  \Frac{1}{2}
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \beta
    \, h_S^{-\!1}
    \left(
      \pi_{\tilde{M}_h}\!\!
      \left\{
        u
        -
        \lambda
        +
        (I-\pi_{X_h}) \, r_h(u,\lambda)
      \right\}
    \right)^2 
    \,\mathrm{d}s
  \\
  M_h(0)
  &=&
  \left\{
    \mu_h\in M_h
    \ ;\ 
    \mu_{h|S} = 0
    ,\ \forall S\subset \partial\Omega
  \right\}
\end{eqnarray*}
In the definition of~$L_1$, the first term
is related to the consistency and the second one
to the stabilization, with a~$\beta\,h_S^{-\!1}$
penalization factor (see~\cite[p.~637]{CocPieErn-2016}, eqns~(2.4)-(2.5)),
while~$h_S$ denotes a local mesh characteristic length in the side~$S\in\mathscr{S}_h$.
\index{penalization}%
Here~$\beta>0$ is the \emph{penalization} parameter,
which is a constant independent of the mesh size~$h$.
The space~$M_h(0)$ for the Lagrange multiplier~$\lambda_h$
is introduced in order to impose the homogeneous Dirichlet condition~\eqref{eq-diffusion-bc}
as a constraint.

The expression of~$L_1$ is not convenient for practical implementation,
as it involves both the reconstruction operator~$r_h$
and the projections~$\pi_{X_h}$ and~$\pi_{\tilde{M}_h}$.
Let us introduce the reconstruction
\mbox{$
  u_h^*
  =
  r_h(u_h,\mu_h)
  \in X_h^*
$}
as an auxilliary variable.
The constraint
\mbox{$
  u_h^*
  -
  r_h(u_h,\mu_h)
  =
  0
$}
is imposed via a Lagrange multiplier
\mbox{$v_h^* \in X_h^*$}.
Both the two additional variables~$u_h^*$ and~$v_h^*$
have a constrained average value
and we also introduce two associated Lagrangian multipliers:
one is denoted by~\mbox{$\zeta_{1,h} \in Z_h$},
associated to the imposition of a zero element-wise average
value for~$u_h^*-u_h$.
the second, \mbox{$\zeta_{2,h} \in Z_h$},
is associated to the imposition of a zero element-wise average
value for~$v_h^*$.
Similarly to the augmented Lagrangian~\eqref{eq-hho-reconstruction-lagrangian},
we introduce a new Lagrangian:
\begin{eqnarray*}
  L_2(u,u^*;~ \lambda,v^*,\zeta_1,\zeta_2)
  &=&
  \int_\Omega
    \left(
      \Frac{1}{2}
      |\nabla_h u^*|_{\boldsymbol{A}}^2
      -
      f \, u
    \right)
    \,\mathrm{d}x
  \\
  &&
  \ + \ 
  \Frac{1}{2}
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \beta
    \, h_S^{-\!1}
    \left(
      \pi_{\tilde{M}_h}\!\!
      \left\{
        u
        -
        \lambda
        +
        u^*
        -
        \pi_{X_h}(u^*)
      \right\}
    \right)^2 
    \,\mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega
    \nabla_h (u^*-u)
    .
    \left(
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    \,\mathrm{d}x
  \ +
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
     (u - \lambda)
    \ 
    \left( 
      \boldsymbol{A}
      \nabla
      v^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega  
    \left\{
      (u^* - u) \,\zeta_1
      +
      v^* \zeta_2
      -
      \dfrac{\alpha\,h^{-\!2}}{2}
      \left(\zeta_1^2 - \zeta_2^2\right)
    \right\}
    \,\mathrm{d}x
\end{eqnarray*}
\index{augmented Lagrangian}%
In the last term,
also have introduced the augmented Lagrangian term
with coefficient~$\alpha>0$, as introduced in the previous
paragraph on the reconstruction operator.
The previous problem in terms of~$L_1$ can be equivalently
expressed as a saddle point for~$L_2$, with six unknowns:
\begin{eqnarray*}
  (u_h,u_h^* ;~ \lambda_h, v_h^*, \zeta_{1,h}, \zeta_{2,h})
  &=&
  \arginf_{\scriptsize
      \begin{array}{c}
        v_h\in X_h \\
        v_h^*\in X_h^*
      \end{array}
  }
  \!\!\!
  \sup_{\scriptsize
      \begin{array}{c}
        \mu_h\!\in\!M_h(0) \\
        w_h^*\in X_h^* \\
        \xi_{1,h} \in Z_h \\
        \xi_{2,h} \in Z_h
      \end{array}
  }
  L_2(v_h,v_h^*;~ \mu_h, w_h^*, \xi_{1,h},\xi_{2,h})
\end{eqnarray*}
The reconstruction operator~$r_h$ has been eliminated,
but the previous expression of~$L_2$ still involves
the two projectors~$\pi_{X_h}$ and~$\pi_{\tilde{M}_h}$.
These explicit calls to the projectors are not convenient for
the practical implementation.
Let us introduce the two auxiliary variables
\mbox{$
  \check{u}_h
  =
  \pi_{X_h}(u_h^*)
  \in X_h
$}
and
\mbox{$
  \tilde{\delta}_h
  =
  \pi_{\tilde{M}_h}(
    u - \lambda
    +
    u_h^* - \check{u}_h
  )
  \in \tilde{M}_h
$}
as two constraints
and the two corresponding Lagrangian multipliers,
$\check{v}_h\in X_h$ and~$\tilde{\gamma}_h\in \tilde{M}_h$,
respectively.
Then, we obtain the following Lagrangian:
\begin{eqnarray*}
  L(u,u^*,\check{u},\tilde{\delta}
        ;~
        \lambda,v^*,\zeta_1,\zeta_2, \check{v},\tilde{\gamma})
  &=&
  \int_\Omega
    \left(
      \Frac{1}{2}
      |\nabla_h u^*|_{\boldsymbol{A}}^2
      -
      f \, u
    \right)
    \,\mathrm{d}x
  +
  \Frac{1}{2}
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \beta
    \, h_S^{-\!1}
    \, \tilde{\delta}^2
    \,\mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega
    \nabla_h (u^*-u)
    .
    \left(
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    \,\mathrm{d}x
  +
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    (u-\lambda)
    \ 
    \left( 
      \boldsymbol{A}
      \nabla
      v^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega  
    \left\{
      (u^* - u) \,\zeta_1
      +
      v^* \zeta_2
      -
      \dfrac{\alpha\,h^{-\!2}}{2}
      \left(\zeta_1^2 - \zeta_2^2\right)
    \right\}
    \,\mathrm{d}x
  \\
  &&
  \ +\ 
  \int_\Omega  
    (u^* - \check{u})
    \, \check{v}
    \,\mathrm{d}x
  +
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    (
        u
        -
        \lambda
        +
        u^*
        -
        \check{u}
      -
      \tilde{\delta}
    )
    \, \tilde{\gamma}
    \,\mathrm{d}s
\end{eqnarray*}
and the previous minimization problem can be equivalently
expressed as a saddle point one with ten unknowns:
\begin{empheq}{align*}
  &
  (u_h,u_h^*,\check{u}_h,\tilde{\delta}_h;~ \lambda_h,v_h^*,\zeta_{1,h},\zeta_{2,h}, \check{v}_h, \tilde{\gamma}_h)
  \\
  &=
  \arginf_{\scriptsize
      \begin{array}{c}
         w_h\in X_h \\
         w_h^*\in X_h^* \\
         \check{w}_h\in X_h \\
         \tilde{\varphi}_h\in \tilde{M}_h
      \end{array}
  }
  \!\!\!
  \sup_{\scriptsize
      \begin{array}{c}
         \mu_h\in M_h(0) \\
         y_h^*\in X_h^* \\
         \xi_{1,h} Z_h \\
         \xi_{2,h} Z_h \\
         \check{y}_h\in X_h \\
         \tilde{\kappa}_h\in \tilde{M}_h
      \end{array}
  }
  L(w_h,w_h^*,\check{w}_h,\tilde{\varphi}_h;~
        \mu_h,y_h^*,\xi_{1,h},\xi_{2,h},\check{y}_h,\tilde{\kappa}_h)
\end{empheq}
Since~$L$ is differentiable and quadratic,
its saddle point is characterized as the unique solution of 
a variational and linear problem:

\ \ $(FV)_h$: \emph{find
$(u_h^*,\zeta_{1,h},\tilde{\delta}_h ;~
  v_h^*,\zeta_{2,h},\tilde{\gamma}_h ;~
  \check{u}_h,\check{v}_h, u_h ;~
  \lambda)
 \in
  \left(X_h^*\times Z_h\times \tilde{M}_h\right)^2 \times
  X_h^3 \times M_h(0)
$
such that}
\begin{eqnarray*}
  &&
  \int_\Omega
    \nabla_h u^*
    .
    (\boldsymbol{A} \nabla_h w^*)
    \, \mathrm{d}x
  -
  \int_\Omega
    f\, w
    \, \mathrm{d}x
  +
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \beta
    \, h_S^{-\!1}
    \, \tilde{\delta}
    \, \tilde{\varphi}
    \, \mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega
    \left\{
      \nabla_h (u^* - u)
      .
      (\boldsymbol{A} \nabla_h y^*)
      +
      \nabla_h (w^* - w)
      .
      (\boldsymbol{A} \nabla_h v^*)
    \right\}
    \, \mathrm{d}x
  \\
  &&
  \ +\ 
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \left\{
      u
      \, (\boldsymbol{A}\nabla y^*).\boldsymbol{n}
      +
      w
      \, (\boldsymbol{A}\nabla v^*).\boldsymbol{n}
    \right\}
    \, \mathrm{d}s
  \\
  &&
  \ +\ 
  \int_\Omega
    \left\{
      (u^*-u)\xi_1
      +
      (w^*-w)\zeta_1
      +
      v^* \xi_2
      +
      y^* \zeta_2
      - 
      \alpha\,h^{-\!2}
      (\zeta_1\xi_1 - \zeta_2\xi_2)
    \right\}
    \, \mathrm{d}x
  \\
  &&
  \ +\ 
  \int_\Omega
    \left\{
      (u^*-\check{u})\check{y}
      +
      (w^*-\check{w})\check{v}
    \right\}
    \, \mathrm{d}x
  \\
  &&
  \ +\ 
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \left\{
      (u+u^*-\check{u}-\tilde{\delta}) \tilde{\kappa}
      +
      (w+w^*-\check{w}-\tilde{\varphi}) \tilde{\gamma}
    \right\}
    \, \mathrm{d}x
  \\
  &&
  -
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \left\{
      \lambda
      \,(\boldsymbol{A}\nabla y^*).\boldsymbol{n}
      +
      \mu
      \,(\boldsymbol{A}\nabla v^*).\boldsymbol{n}
    \right\}
    \,\mathrm{d}s
  \\
  &&
  -
  \sum_{K\in\mathscr{T}_h}
  \sum_{S\subset\partial K}
  \int_{S}
    \left(
      \lambda \, \tilde{\kappa}
      +
      \mu \, \tilde{\gamma}
    \right)
    \,\mathrm{d}s
  \\
  &=&
  0
\end{eqnarray*}
for all
$(w_h^*,\xi_{1,h},\tilde{\varphi}_h ;~
  y_h^*,\xi_{2,h},\tilde{\kappa}_h ;~
  \tilde{w}_h,\check{y}_h, w_h ;~
  \mu)
 \in
  \left(X_h^*\times Z_h\times \tilde{M}_h\right)^2 \times
  X_h^3 \times M_h(0)
$.
The~$h$ subscripts for the unknowns and test functions have been
omitted for simplicity in the variational expression.
This system could appear as complex.
But observe that all discretization are piecewise discontinuous at the element level
except those for~$\lambda_h\in M_h(0)$.
Then, all variables except this one could be eliminated at the element level.
In order to process to this elimination,
the previous variational formulation is rearranged
as a matrix block structure:
\begin{empheq}{align*}
  \left(
  \begin{array}{c||cccc|cccc|c||c}
                  & u^*         & \zeta_1 & v^*          & \zeta_2 & \tilde{\delta} & \tilde{\gamma} & \check{u}  & \check{v} & u          & \lambda      \\ \hline\hline
%
    w^*           & a_*         & b_*^T   & a_*          &         &                & \tilde{d}_*^T  &            & d_*^T     &            &              \\ \hline
    \xi_1         & b_*         & -c_*    &              &         &                &                &            &           & -d         &              \\ \hline
    y^*           & a_*         &         &              & b_*^T   &                &                &            &           & -\check{a} & -e_*^T       \\ \hline     
    \xi_2         &             &         & b_*          & c_*     &                &                &            &           &            &              \\ \hline \hline
%
   \tilde{\varphi}&             &         &              &         & \tilde{c}      & -\tilde{m}     &            &           &            &              \\ \hline
   \tilde{\kappa} & \tilde{d}_* &         &              &         & -\tilde{m}     &                & -\tilde{d} &           & \tilde{d}  & -\tilde{e}^T \\ \hline
%
    \check{w}     &             &         &              &         &                & -\tilde{d}^T   &            & -m        &            &              \\ \hline
    \check{y}     & d_*         &         &              &         &                &                & -m         &           &            &              \\ \hline \hline
%
    w             &             & -d^T    & -\check{a}^T &         &                & \tilde{d}^T    &            &           &            &              \\ \hline \hline
%
    \mu           &             &         & -e_*         &         &                & -\tilde{e}     &            &           &            &             %\\ \hline
  \end{array}
  \right)
  \left(
  \begin{array}{c}
                     \\%\hline\hline
%
    u_h^*            \\ \hline
    \zeta_{1,h}      \\ \hline
    v_h^*            \\ \hline
    \zeta_{2,h}      \\ \hline \hline
%
    \tilde{\delta}_h \\ \hline
    \tilde{\gamma}_h \\ \hline
    \check{u}_h      \\ \hline
    \check{v}_h      \\ \hline \hline
%
    u_h              \\ \hline \hline
%
    \lambda_h      % \\ \hline
  \end{array}
  \right)
  =
  \left(
  \begin{array}{c}
           \\ % \hline\hline
    0      \\ \hline
    0      \\ \hline
    0      \\ \hline
    0      \\ \hline\hline
%
    0      \\ \hline
    0      \\ \hline
    0      \\ \hline
    0      \\ \hline
    \ell_h \\ \hline\hline
%
    0     %\\ \hline
  \end{array}
  \right)
\end{empheq}
The matrix are identified to the corresponding forms
and we have introduce thirteen bilinear forms and a linear form.
A first group of five bilinear forms is
associated to symmetric positive matrix
plus the right-hand-side~$\ell_h$:
\begin{empheq}{alignat*=2}
  a_*(u^*,w^*)
  &=
  \int_\Omega  
    \nabla_h u^*
    .
    \left( 
      \boldsymbol{A}
      \nabla_h w^*
    \right)
    \,\mathrm{d}x
  &\quad
  \phantom{mmm}
  \ell_h(w)
  &=
  \int_\Omega  
    f \, w
    \,\mathrm{d}x
  \\
  m(u,w)
  &=
  \int_\Omega
    u\,w
    \,\mathrm{d}x
  &\quad
  \tilde{m} (\tilde{\delta},\tilde{\varphi})
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \tilde{\delta}\, \tilde{\varphi}
    \,\mathrm{d}s
  \\
  c_*(\zeta,\xi)
  &=
  \int_\Omega  
    \alpha\,
    h^{-\!2}
    \zeta \, \xi
    \,\mathrm{d}x
  &\quad
  \tilde{c}(\tilde{\delta},\tilde{\varphi})
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \beta\, h_{S}^{-\!1}
    \tilde{\delta}\, \tilde{\varphi}
    \,\mathrm{d}s
\end{empheq}
All the associated matrix are symmetric definite positive,
and then invertible, except~$a_*$, which is only symmetric positive
but has a zero eigenvalue.
The second group corresponds to rectangular matrix:
\begin{empheq}{alignat*=2}
  b_*(u^*,\xi)
  &=
  \int_\Omega  
    u^* \xi
    \,\mathrm{d}x
  &\quad
  &
  \\
  d(u,\xi)
  &=
  \int_\Omega
      u\, \xi
    \,\mathrm{d}x
  &\quad
  \tilde{d}(u,\tilde{\varphi})
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    u\, \tilde{\varphi}
    \,\mathrm{d}s
  \\
  d_*(u^*,w)
  &=
  \int_\Omega
    u^*\,w
    \,\mathrm{d}x
  &\quad
  \phantom{mmmmmmm}
  \tilde{d}_*(u^*,\tilde{\varphi})
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    u^*\, \tilde{\varphi}
    \,\mathrm{d}s
\end{empheq}
\begin{empheq}{align*}
  \check{a}(u,w^*)
  &=
  \int_\Omega
    \nabla_h u
    .
    \left( 
      \boldsymbol{A}
      \nabla_h w^*
    \right)
    \,\mathrm{d}x
  -
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    u
    \, 
    \left( 
      \boldsymbol{A}
      \nabla_h w^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
\end{empheq}
These two groups admit a block-diagonal structure at the element level,
due to the piecewise discontinuous character of the trial and test functions.
In the following third group, bilinear forms
corresponds to rectangular matrix with non-block-diagonal structure,
due to the inter-element continuity of~$\mu\in Mh$:
\begin{empheq}{alignat*=2}
  e_*(v^*,\mu)
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \mu
    \,
    \left( 
      \boldsymbol{A}
      \nabla_h v^*
    \right)
    .
    \boldsymbol{n}
    \,\mathrm{d}s
  &\quad
  \phantom{mmmm}
  \tilde{e}(\tilde{\gamma},\mu)
  &=
  \sum_{K\in\mathscr{T}_h}
  \int_{\partial K}
    \tilde{\gamma}
    \, \mu
    \,\mathrm{d}s
\end{empheq}
Let us process to the elimination of all the unknowns except~$\lambda_h$.
For simplicity, the matrix subequations are designated by the corresponding
test-function surrounded by parenthesis, such as~$(w^*)$ for the first one.
\begin{subequations}
Let us start by eliminating some variables related to projections:
from~$(\check{y})$, $(\tilde{w})$ and~$(\tilde{\varphi})$,
we get, respectively:
\begin{empheq}{align}
  \check{u}
    &=
    \phantom{-}
    m^{-\!1} d_* u^*
    \label{eq-hho-elim-check-u}
  \\
  \check{v}
    &=
    -
    m^{-\!1} \tilde{d}^T \tilde{\gamma}
    \label{eq-hho-elim-check-v}
    \\
  \tilde{\gamma}
    &=
    \tilde{m}^{-\!1}
    \tilde{c} \,
    \tilde{\delta}
    \label{eq-hho-elim-tilde-gamma}
\end{empheq}
The following subexpression will be frequently involved:
\begin{empheq}{align*}
  d_*^T \check{v}
  +
  \tilde{d}_*^T \tilde{\gamma}
    &=
    D^T
    \tilde{\delta}
  \\
  \textrm{with }\ \  
  D
    &=
    \tilde{c}\,
    \tilde{m}^{-\!1}
    \tilde{D}_*
  \\
  \tilde{D}_*
    &=
    \tilde{d}_*
     -
     \tilde{d}\,
     m^{-\!1}
     d_*
\end{empheq}
Next, let us turn to variables related to the reconstruction.
from~$(\xi_1)$ and $(w^*)$, we get:
we obtain successively:
\begin{empheq}{align}
  \zeta_1
    &=
    c_*^{-\!1} 
    \left(
      b_* u^*
      -
      d u
    \right)
    \label{eq-hho-elim-zeta1-1}
    \\
  u_*
    &=
    S_*^{-\!1}
    \left(
      -
      a_* v^*
      -
      D^T \tilde{\delta}
      +
      b_*^T c_*^{-\!1} d\, u
    \right)
    \label{eq-hho-elim-us-1}
    \\
  \textrm{with }\ \ 
  S_*
  &=
  a_* + b_*^T c_*^{-\!1} b_*
    \nonumber
\end{empheq}
Conversely, from~$(\xi_2)$, $(y^*)$ and~\eqref{eq-hho-elim-us-1}
\begin{empheq}{align}
  \zeta_2
    &=
    -
    c_*^{-\!1} 
    b_* v^*
    \label{eq-hho-elim-zeta2-1}
    \\
  v^*
    &=
    T^{-\!1}
    \left(
      -
      a_* S_*^{-\!1} D^T \tilde{\delta}
      +
      R u
      -
      e_*^T \lambda
    \right)
    \label{eq-hho-elim-vs}
    \\
  \textrm{with }\ \ 
  T
    &=
    a_* S_*^{-\!1} a_*
    +
    b_*^T c_*^{-\!1} b_*
    \nonumber
    \\
  R
    &=
    a_* S_*^{-\!1} b_*^T c_*^{-\!1} d 
    -
    \check{a}
    \nonumber
\end{empheq}
Back-substituting in~\eqref{eq-hho-elim-zeta1-1}-\eqref{eq-hho-elim-us-1}:
\begin{empheq}{align}
  u_*
    &=
    -
    \left(
      S_*^{-\!1}
      -
      S_*^{-\!1}
      a_* T^{-\!1} a_*
      S_*^{-\!1}
    \right)
    D^T \tilde{\delta}
    +
    S_*^{-\!1}
    \left(
      b_*^T c_*^{-\!1} d
      -
      a_* T^{-\!1} R
    \right)
    u
    +
    S_*^{-\!1}
    a_*
    T^{-\!1}
    e_*^T
    \lambda
    \label{eq-hho-elim-us}
  \\
  \zeta_1
    &=
    -
    c_*^{-\!1} 
    b_* 
    \left(
      S_*^{-\!1}
      -
      S_*^{-\!1} 
      a_* T^{-\!1} a_*
      S_*^{-\!1}
    \right)
    D^T \tilde{\delta}
    \nonumber
    \\
    &
    +
    c_*^{-\!1} 
    \left[
      b_* 
      S_*^{-\!1} 
      \left(
        b_*^T c_*^{-\!1} d
        -
        a_* T^{-\!1} R
      \right)
      -
      d
    \right]
    u
    \nonumber
    \\
    &
    +
    c_*^{-\!1} 
    b_* 
    S_*^{-\!1} 
    a_* 
    T^{-\!1} 
    e_*^T \lambda
    \label{eq-hho-elim-zeta1}
\end{empheq}
Then, replacing~\eqref{eq-hho-elim-tilde-gamma},
\eqref{eq-hho-elim-vs} and~\eqref{eq-hho-elim-zeta1}
in~$(w)$, we obtain:
\begin{empheq}{align}
  A_c u
    +
    &
    \tilde{E} \tilde{\delta}
    -
    R^T T^{-\!1} e_*^T
    \lambda
    =
    \ell
    \label{eq-hho-elim-u-tmp-1}
    \\
  \textrm{with }\ \  
  A_c
    &=
    R^T T^{-\!1} R
    +
    d^T \left( c_*^{-\!1} - c_*^{-\!1} b_* S_*^{-\!1} b_*^T c_*^{-\!1} \right) d
    \nonumber
    \\
    &=
    R^T T^{-\!1} R
    \nonumber
    \\
    & \textrm{since }\ 
    {c_* = b_* S_*^{-\!1} b_*^T}
    % \red{\textrm{\ \  TODO: prove it!}}
    \nonumber
    \\
  \tilde{E}
    &=
    \tilde{d}^T \tilde{m}^{-\!1} \tilde{c}
    +
    \check{a}^T T^{-\!1} a_* S_*^{-\!1} D^T
    +
    d^T c_*^{-\!1} b_*
    \left(
      S_*^{-\!1}
      -
      S_*^{-\!1} 
      a_* T^{-\!1} a_*
      S_*^{-\!1}
    \right)
    D^T
    \nonumber
\end{empheq}
It remains to express~$\tilde{\delta}$ in terms of~$u$ and~$\lambda$.
From~$(\tilde{\kappa})$ and~\eqref{eq-hho-elim-check-u}:
\begin{empheq}{align*}
  \tilde{m}
  \tilde{\delta}
    -
    \tilde{D}_* 
    u^*
    -
    \tilde{d} u
    +
    \tilde{e}^T \lambda
    &=
    0
\end{empheq}
Left-multiplying by 
$\tilde{c}\tilde{m}^{-\!1}$
and substituting~\eqref{eq-hho-elim-us}, we get
\begin{empheq}{align}
  \tilde{\delta}
    &=
    \tilde{M}^{-\!1}
    \left(
      \tilde{E}^T u
      +
      F^T \lambda
    \right)
    \label{eq-hho-elim-tilde-delta}
    \\
  \tilde{M}
    &=
    \tilde{c}
    +
    D
    \left(
      S_*^{-\!1}
      -
      S_*^{-\!1}
      a_*
      T^{-\!1}
      a_*
      S_*^{-\!1}
    \right)
    D^T
    \nonumber
    \\
  F
    &=
    e_*
    T^{-\!1}
    a_*
    S_*^{-\!1}
    D^T
    -
    \tilde{e}\,
    \tilde{m}^{-\!1}
    \tilde{c} \,
    \nonumber
\end{empheq}
Replacing in \eqref{eq-hho-elim-u-tmp-1}, we get
\begin{empheq}{align}
  A u
    +
    B^T
    \lambda
    &
    =
    \ell
    \label{eq-hho-elim-sys-u}
  \\
  \textrm{with }\ \  
  A
    &=
    A_c + A_s 
    \nonumber
    \\
  A_s
    &= 
    \tilde{E} \tilde{M}^{-\!1} \tilde{E}^T
    \nonumber
    \\
  B
    &=
    F \tilde{M}^{-\!1} \tilde{E}^T
    -
    e_* T^{-\!1} R
    \nonumber
\end{empheq}
Here, $A_c$ represents the consistency part of the operator~$A$
while $A_s$ is the stabilization part, i.e. the penalization.
Finally, $(\mu)$ becomes
\begin{empheq}{align}
  B u
    +
    C \lambda
    &=
    0
    \label{eq-hho-elim-sys-lambda}
    \\
  \textrm{with }\ \  
  C
    &=
    e_* T^{-\!1} e_*^T
    +
    F M^{-\!1} F^T
\end{empheq}
From~\eqref{eq-hho-elim-sys-u}-\eqref{eq-hho-elim-sys-lambda}, we get
\begin{empheq}{align*}
  u
    &=
    A^{-\!1}
    (\ell - B^T \lambda)
    \\
  S \lambda
    &=
    f
  \\
  \textrm{with }\ \  
  S 
    &=
    C - B A^{-\!1} B^T
    \\
  f 
    &=
    - B A^{-\!1} \ell
\end{empheq}

\begin{comment}
\red{TODO:
$C\geq 0$ et~$S\geq 0$ mais $BA^{-1}B^T\geq 0$~:
$S*$ est la difference de deux quantites postivites
mais reste positive.
Peut-on montrer que $S$ est tjs positive~?
Oui, d'apres
\citet{PieDro-2020-hho}, page~458 en bas.
Ils citent~\cite{Zha-2005-schur}, page~34, theorem~1.12.a.
Cela suggere que \mbox{$\mathcal{A}=[A,Bt;B,c] > 0$} aussi.
Peut- etre que ca se montre par coercivite en~$(u,\lambda)$~?

Aussi, restera a voir si cette difference devient petite
devant les deux quantites~: pb de precision~?
Autre expression plus robuste et directe~?
}%red
\end{comment}

\end{subequations}
The following code implements this technique:

\vfill

% -------------------------------------
\myexamplelicense{dirichlet_hho.cc}

\myexamplelicense{dirichlet_homogeneous.h}
% -------------------------------------

As usual, the right-hand-side~$f$ and the Dirichlet boundary condition~$g$
has been chosen such that the exact solution is given by:
\begin{equation*}
  u(x) = \prod_{i=0}^{d\!-\!1} \sin(\pi x_i)
\end{equation*}
%% The~\file{sinusprod_error_hdg.cc}, that compute the error
%% in various norms, are not listed here but are available in the \Rheolef\  example directory.


%---------------------------------------
\subsubsection*{How to run the program}
%---------------------------------------
\begin{figure}[htb]
  \begin{center}
    \begin{tabular}{ll}
      \includegraphics[width=0.42\textwidth]{dirichlet-hho-k-k-t-us-l2.pdf} &
      \includegraphics[width=0.42\textwidth]{dirichlet-hho-k-k-t-us-h1.pdf}
    \end{tabular}
  \end{center}
  \caption{Hybrid hight-order (HHO) method:
	error vs~$h$ and~$k$ for the Poisson problem.
  }
  \label{fig-dirichlet-hho}
\end{figure}

The compilation and run write:
\begin{verbatim}
  make dirichlet_hho
  mkgeo_grid -t 10 > square.geo
  ./dirichlet_hho square.geo P1d > square.field
  field square.field -elevation
  field square.field -elevation -mark u
  field square.field -elevation -mark lambda
\end{verbatim}
Observe the better behavior of the~$u_h^*$
approximate solution, obtained by reconstruction,
when compared with the original one~$u$.
The error versus the mesh refinement~$h$
and the polynomial orer~$k$ is plotted on
Fig.~\ref{fig-dirichlet-hho}.
These numerical experiments confirm
the theoretical predictions (see e.g.~\citet{PieDro-2020-hho},
pages~65 and~68):
\begin{empheq}{align*}
  \| u_h^* - u \|_{0,2,\Omega} &= \mathcal{O}(h^{k+2})
	\\
  \| \nabla_h(u_h^* - u) \|_{0,2,\Omega} &= \mathcal{O}(h^{k+1})
\end{empheq}

\begin{figure}[htb]
  \begin{center}
    \begin{tabular}{ll}
      \includegraphics[width=0.42\textwidth]{dirichlet-hho-k-k-t-us-cpu.pdf} &
    \end{tabular}
  \end{center}
  \caption{
        Comparison of
	hybrid hight-order (HHO) method (continuous lines)
	with
        classical Lagrange continuous approximation (dotted lines).
	Error vs CPU time for various~$h$ and~$k$ for the Poisson problem.
        The test bases on a bidimensional triangular mesh and a direct sequential solver
	(no parallel computation).
  }
  \label{fig-dirichlet-hho-cpu}
\end{figure}
%
% voir PieDro-2020-hho page 75 Fig 2.5 :
%   comparer : ils en tirent un comportement asymptotique
%   err = f(k,d) = t_cpu**((k+2)/d)
% voir GibMitHamCot-2019 Fig 2.a :
%   en HDG : compare err vs CPU aussi 
%   et avec Lagrange continu : ils sont plus proche !
%   ils sont en 3d avec solveur iteratif + precond AMG (petsc?)
%   leur conclusion :
%     "The extra cost of HDG due to the larger
%      degree-of-freedom count and the need to perform local tensor inversion
%      is offset by the local conservation and stabilization properties
%       which are useful for fluid dynamics applications."
%   Ils decomposent par etape : le solver domine, mais sont en 3D-iteratif
%   ici : 2D-direct c'est peut-etre l'assemblage ?
%   => decomposer aussi par etape
%   2D-direct : tracer S.nnz et fact(S).nnz vs (h,k) : cmp avec dirichlet.cc
%
Fig.~\ref{fig-dirichlet-hho-cpu} plots the $L^2$ error
for~$u^*_h$ versus the CPU time required to its computation
for various mesh refinement~$h$ and polynomial order~$k$.
It compares it with the~$L^2$ error for obtaining the~$P_{k+1}$
continuous Lagrange solution.
While increasing the polynomial order~$k$,
the slope of convergence of the error versus~$h$ appears to be higher
than its counterpart with the
classical Lagrange continuous approximation (dotted lines).
%
Thus, the HHO method appears to be asymptotically more efficient
when~$h\rightarrow 0$ i.e. large meshes and high CPU times.
Nevertheless, the constant in front of this asymptotical HHO
method is higher
than its counterpart with the
classical Lagrange continuous approximation,
and thus, when the mesh is medium or small, the classical
method is still faster.
%
The constant of the HHO method is due to algebraic manipulations,
such as assembly and matrix-matrix products at the element level:
it could certainly be decreased by a more efficient
implementation of the HHO method, and this perspective
will be explorated in the future.
